from openerp import api, fields, models

class ResPartner(models.Model):
    _inherit = 'res.partner'

    @api.model
    def get_customers(self):
        domain = [('customer', '=', True), ('active', '=', True)]
        customers = []

        for customer in self.env['res.partner'].search(domain):
            categories = []

            for category in customer.category_id:
                categories.append({
                    'id': category.id,
                    'name': category.name,
                    'display_name': category.display_name
                })

            customers.append({
                'id': customer.id,
                'name': customer.name,
                'display_name': customer.display_name,
                'ruc': customer.ruc,
                'image_medium': customer.image_medium,
                'phone': customer.phone,
                'mobile': customer.mobile,
                'email': customer.email,
                'credit': customer.credit,
                'credit_limit': customer.credit_limit,
                'categories': categories
            })
        

        return customers